/*------------------------------------------------------------------________----------------------------------
Author     : Rey Ocampo
Company    : Husky Energy
Description: Utility class for Service Notification Request
Inputs     : N/A
Test Class : ServiceRequestNotificationUtilitiesTest
History    : 
            03-Feb-15   Gangha Kaliyan  To change operator lookups from contact to user
            10.06.15    rbo Added readObjectRecordTypeId(), Recurrence(), NotificationRecordType()
                            Removed createRiglessWorkOrder() and replaced it with createServiceWorkOrder()
                            ServiceRequest() for Tech Debt fixes  
            01.08.16    rbo Modifications due to Refactoring
                            replaced all HOG_Rigless_Servicing_Form__c with HOG_Maintenance_Servicing_Form__c
            01.28.16    SM added Equipment_Down__c in SOQL in readServiceNotificationRequests                           
            01.29.16    rbo added HOG_Service_Required__r.HOG_Service_Code_Group__r.Code_Group__c in
                            readServiceNotificationRequests 
            01.29.16    rbo modified readWellTrackerAverageOilProduction to return scaled value
            10.04.17    mz added operator detail on wo for new snr - wo email notification [W-000843]
            10.30.17    mz added user details in readServiceNotificationRequests
            11.06.18    mp W-001115 Ability to edit Vendor Invoicing and Personnel without deleting previous information
            12-Jul-2018 mz: FIX for 2Z for null element in set causing innacurate information in email template
            03.04.19    mb W-001435 - prepopulating GL codes for Rigless
-------------------------------------------------------------------------------------------------------------*/ 
public with sharing class ServiceRequestNotificationUtilities
{       
    
    public final static Integer LENGTHSAPMAINDESC = 40;
    
    /***********************************************************************************************
     * Utility used to execute the Trigger code, value defaults to true
     ***********************************************************************************************/    
    public static Boolean executeTriggerCode = true;


    public final static String BAPI_YARD_WO_ERROR_MESSAGE = 'Function BAPI_ALM_ORDER_MAINTAIN returned with type E. Order %00000000001';            


    /*****************************************************************************************************************
     * Code manager of "before insert" trigger of HOG_Maintenance_Servicing_Form
     *****************************************************************************************************************/    
    public static void TriggerBeforeInsertServiceRequestNotificationForm(final List<HOG_Service_Request_Notification_Form__c> newRecords)
    {
        for (HOG_Service_Request_Notification_Form__c serviceNotificationForm : newRecords)
        {
            //serviceNotificationForm.addError('You can not create a notification order record.');
        }            
    }

    /**********************************************************************************************************
     * Code manager of "before delete" trigger of HOG_Maintenance_Servicing_Form
     **********************************************************************************************************/    
    public static void TriggerBeforeDeleteServiceRequestNotificationForm(final List<HOG_Service_Request_Notification_Form__c> oldRecords)
    {
        for (HOG_Service_Request_Notification_Form__c serviceNotificationForm : oldRecords)
        {
            //serviceNotificationForm.addError('You can not delete a notification order record.');
        }    
    }
        

    /**********************************************************************************************************
     * Code manager of "before update" trigger of HOG_Maintenance_Servicing_Form
     **********************************************************************************************************/    
    public static void TriggerBeforeUpdateServiceRequestNotificationForm(final List<HOG_Service_Request_Notification_Form__c> newRecords, 
    final Map<Id, HOG_Service_Request_Notification_Form__c> oldMap)
    {
        for (HOG_Service_Request_Notification_Form__c serviceNotificationForm : newRecords)
        {
            serviceNotificationForm.addError('You can not update a notification order record.');
        }    
    }

    public static void TriggerBeforeInsertVendorPersonnel(final List<HOG_Vendor_Personnel__c> vendorPersonnelList) {
        Set<Id> workOrderIdSet = new Set<Id>();
        Map<Id, HOG_Maintenance_Servicing_Form__c> workOrderMap = new Map<Id, HOG_Maintenance_Servicing_Form__c>();

        for(HOG_Vendor_Personnel__c vendorPersonnel : vendorPersonnelList) {
            workOrderIdSet.add(vendorPersonnel.Work_Order__c);
        }

        workOrderMap = new Map<Id, HOG_Maintenance_Servicing_Form__c>([SELECT Service_Status__c
                                                                       FROM HOG_Maintenance_Servicing_Form__c
                                                                       WHERE Id IN :workOrderIdSet]);

        for(HOG_Vendor_Personnel__c vendorPersonnel : vendorPersonnelList) {
            if(workOrderMap.get(vendorPersonnel.Work_Order__c).Service_Status__c == 'Complete')
                vendorPersonnel.addError('You can not create a record of Vendor Invoicing & Personnel, you must first set the Rigless Service Status to a status other than "Complete".');
        }
    }

    public static void TriggerBeforeUpdateVendorPersonnel(final List<HOG_Vendor_Personnel__c> vendorPersonnelList) {
        Set<Id> workOrderIdSet = new Set<Id>();
        Map<Id, HOG_Maintenance_Servicing_Form__c> workOrderMap = new Map<Id, HOG_Maintenance_Servicing_Form__c>();

        for(HOG_Vendor_Personnel__c vendorPersonnel : vendorPersonnelList) {
            workOrderIdSet.add(vendorPersonnel.Work_Order__c);
        }

        workOrderMap = new Map<Id, HOG_Maintenance_Servicing_Form__c>([SELECT Service_Status__c
                                                                       FROM HOG_Maintenance_Servicing_Form__c
                                                                       WHERE Id IN :workOrderIdSet]);
        
    }

    public static void TriggerBeforeDeleteVendorPersonnel(final List<HOG_Vendor_Personnel__c> vendorPersonnelList) {
        Set<Id> workOrderIdSet = new Set<Id>();
        Map<Id, HOG_Maintenance_Servicing_Form__c> workOrderMap = new Map<Id, HOG_Maintenance_Servicing_Form__c>();

        for(HOG_Vendor_Personnel__c vendorPersonnel : vendorPersonnelList) {
            workOrderIdSet.add(vendorPersonnel.Work_Order__c);
        }

        workOrderMap = new Map<Id, HOG_Maintenance_Servicing_Form__c>([SELECT Service_Status__c
                                                                       FROM HOG_Maintenance_Servicing_Form__c
                                                                       WHERE Id IN :workOrderIdSet]);

        for(HOG_Vendor_Personnel__c vendorPersonnel : vendorPersonnelList) {
            if(workOrderMap.get(vendorPersonnel.Work_Order__c).Service_Status__c == 'Complete')
                vendorPersonnel.addError('You can not delete any record of Vendor Invoicing & Personnel, you must first set the Rigless Service Status to a status other than "Complete".');
        }
    }

    public static void TriggerAfterInsertVendorPersonnel(final List<HOG_Vendor_Personnel__c> vendorPersonnelList) {
        updateWorkOrders(vendorPersonnelList);
    }

    public static void TriggerAfterUpdateVendorPersonnel(final List<HOG_Vendor_Personnel__c> vendorPersonnelList) {
        updateWorkOrders(vendorPersonnelList);
    }

    public static void TriggerAfterDeleteVendorPersonnel(final List<HOG_Vendor_Personnel__c> vendorPersonnelList) {
        updateWorkOrders(vendorPersonnelList);
    }

    private static void updateWorkOrders(final List<HOG_Vendor_Personnel__c> vendorPersonnelList) {
        Set<Id> workOrderIdSet = new Set<Id>();
        List<HOG_Maintenance_Servicing_Form__c> workOrdersToUpdate = new List<HOG_Maintenance_Servicing_Form__c>();

        for(HOG_Vendor_Personnel__c vendorPersonnel : vendorPersonnelList) {
            workOrderIdSet.add(vendorPersonnel.Work_Order__c);
        }

        for(HOG_Maintenance_Servicing_Form__c workOrder : [SELECT Id, Name, Vendor_Company__c, Unit_Number__c, Stop_Time__c,
                                                                  Date_Completed__c,
                                                                  (SELECT Id, Name, Vendor__c,
                                                                          Unit_Number__c, Off_Location_Time__c,
                                                                          On_Location_Time__c
                                                                   FROM Vendors_For_Rigless_Servicing__r
                                                                   WHERE On_Location_Time__c != NULL
                                                                   AND Off_Location_Time__c != NULL
                                                                   ORDER BY CreatedDate)
                                                           FROM HOG_Maintenance_Servicing_Form__c
                                                           WHERE Id IN :workOrderIdSet]) {
            if(workOrder.Vendors_For_Rigless_Servicing__r != null && !workOrder.Vendors_For_Rigless_Servicing__r.isEmpty()) {
                workOrder.Vendor_Company__c = workOrder.Vendors_For_Rigless_Servicing__r[0].Vendor__c;
                workOrder.Unit_Number__c = workOrder.Vendors_For_Rigless_Servicing__r[0].Unit_Number__c;
                for(HOG_Vendor_Personnel__c vendorPersonnel : workOrder.Vendors_For_Rigless_Servicing__r) {
                    workOrder.Start_Time__c = (workOrder.Start_Time__c == null || vendorPersonnel.On_Location_Time__c < workOrder.Start_Time__c) ?
                        vendorPersonnel.On_Location_Time__c : workOrder.Start_Time__c;
                    workOrder.Stop_Time__c = (workOrder.Stop_Time__c == null || vendorPersonnel.Off_Location_Time__c > workOrder.Stop_Time__c) ? 
                        vendorPersonnel.Off_Location_Time__c : workOrder.Stop_Time__c;
                    workOrder.Date_Completed__c = (workOrder.Stop_Time__c == null || vendorPersonnel.Off_Location_Time__c > workOrder.Stop_Time__c) ? 
                        vendorPersonnel.Off_Location_Time__c : workOrder.Stop_Time__c;
                }
            } else {
                workOrder.Vendor_Company__c = null;
                workOrder.Unit_Number__c = null;
                workOrder.Start_Time__c = null;
                workOrder.Stop_Time__c = null;
                workOrder.Date_Completed__c = null;               
            }

            workOrdersToUpdate.add(workOrder);
        }

        update workOrdersToUpdate;
    }
        
    /************************************************************************************************
     * Returns a the Rigless Servicing record type given the Service Request's HOG_Work_Order_Type__c
     * workOrderType - The Service Request's HOG_Work_Order_Type__c
     ************************************************************************************************/
    public static String readRiglessRecordType(String workOrderType)
    {

        String riglessRecordTypeId = '';
        
        try {

            String recordTypeName =
                [SELECT
                    Record_Type_Name__c
                FROM HOG_Work_Order_Type__c
                WHERE Id = :workOrderType LIMIT 1].Record_Type_Name__c;

            riglessRecordTypeId = 
                [SELECT
                    Id 
                FROM RecordType WHERE SobjectType = 'HOG_Maintenance_Servicing_Form__c' AND Name = :recordTypeName
                LIMIT 1].Id;
        } catch (Exception e)  {
            System.debug('\n***************************************\n'
                + 'METHOD: ServiceRequestNotificationUtilities.readRiglessRecordType()'
                + '\nException: ' + e.getMessage()
                + '\n***************************************\n');
            throw e;
        }

        return riglessRecordTypeId;        
    }

    
    /**************************************************************************************************
     * Returns a Rigless Servicing record
     * serviceRequest - Service Request class
     **************************************************************************************************/
    public static HOG_Maintenance_Servicing_Form__c createServiceWorkOrder
    (
        ServiceRequest serviceRequest
    )
    {
       System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.createRiglessWorkOrder()'
            + '\nrserviceRequest: ' + serviceRequest
            + '\n***************************************\n');
                
        HOG_Maintenance_Servicing_Form__c riglessServicingForm;
        
        try
        {
            Id operator1;
            Id operator2;
            Id operator3;
            Id operator4;
            Id operator5;
            Id operator6;
            
            Id fieldSenior;
            
            String operator1Detail;
            String operator2Detail;
            String operator3Detail;
            String operator4Detail;
            String operator5Detail;
            String operator6Detail;
            
            String operator1_2Z;
            String operator2_2Z;
            String operator3_2Z;
            String operator4_2Z;
            String operator5_2Z;
            String operator6_2Z;
                            
            List<Route__c> operatorRoute =  [SELECT Operator_1_User__c, 
                                                    Operator_2_User__c, 
                                                    Operator_3_User__c, 
                                                    Operator_4_User__c,
                                                    Operator_5_User__c,
                                                    Operator_6_User__c,
                                                    Operator_1_Name__c,
                                                    Operator_2_Name__c,
                                                    Operator_3_Name__c,
                                                    Operator_4_Name__c,
                                                    Operator_5_Name__c,
                                                    Operator_6_Name__c,
                                                    Mobile_Phone1__c,
                                                    Mobile_Phone2__c,
                                                    Mobile_Phone3__c,
                                                    Mobile_Phone4__c,
                                                    Mobile_Phone5__c,
                                                    Mobile_Phone6__c,
                                                    Field_Senior__c
                                            FROM Route__c 
                                            WHERE Id = :serviceRequest.record.Operator_Route_Lookup__c];
                
            if (!operatorRoute.isEmpty()) {
                operator1 = operatorRoute[0].Operator_1_User__c;
                operator2 = operatorRoute[0].Operator_2_User__c;
                operator3 = operatorRoute[0].Operator_3_User__c;
                operator4 = operatorRoute[0].Operator_4_User__c;
                operator5 = operatorRoute[0].Operator_5_User__c;
                operator6 = operatorRoute[0].Operator_6_User__c;
                fieldSenior = operatorRoute[0].Field_Senior__c;
                
                Set<Id> operatorIdSet = new Set<Id>{operator1, operator2, operator3,
                                                    operator4, operator5, operator6};
                                                    
                //12-Jul-2018 mz: remove null element from Set - it would cause innacurate query result 
                if(operatorIdSet.contains(null)){
                        operatorIdSet.remove(null);
                }
                
                //if SNR is on Location, populate operator details on work order (for use in email notification of new order created)
                if (serviceRequest.record.Location_Lookup__c <> null){
                    
                    List<Contact> contacts = [SELECT Name, User__c, X2Z_Employee_ID__c 
                                              FROM Contact 
                                              WHERE User__c IN :operatorIdSet 
                                              AND X2Z_Employee_ID__c <> NULL];
                    
                    for (Contact c : contacts){

                        if (c.User__c == operator1){
                            operator1_2Z = c.X2Z_Employee_ID__c; 
                        }

                        if (c.User__c == operator2){
                            operator2_2Z = c.X2Z_Employee_ID__c; 
                        }

                        if (c.User__c == operator3){
                            operator3_2Z = c.X2Z_Employee_ID__c; 
                        }

                        if (c.User__c == operator4){
                            operator4_2Z = c.X2Z_Employee_ID__c; 
                        }

                        if (c.User__c == operator5) {
                            operator5_2Z = c.X2Z_Employee_ID__c;
                        }

                        if (c.User__c == operator6) {
                            operator6_2Z = c.X2Z_Employee_ID__c;
                        }
                     } 
                     
                    
                    //operator details: User Name [Route__c.User] | 2Z Employee Number [Contact] | Mobile [Route__c.User]
                    operator1Detail = (operatorRoute[0].Operator_1_User__c <> null ? operatorRoute[0].Operator_1_Name__c : 'N/A') + ' | ' + 
                                      (operator1_2Z <> null ? operator1_2Z : 'N/A') + ' | ' + 
                                      (operatorRoute[0].Mobile_Phone1__c <> null ? operatorRoute[0].Mobile_Phone1__c : 'N/A');
                    operator2Detail = (operatorRoute[0].Operator_2_User__c <> null ? operatorRoute[0].Operator_2_Name__c : 'N/A') + ' | ' + 
                                      (operator2_2Z <> null ? operator2_2Z : 'N/A') + ' | ' + 
                                      (operatorRoute[0].Mobile_Phone2__c <> null ? operatorRoute[0].Mobile_Phone2__c : 'N/A');
                    operator3Detail = (operatorRoute[0].Operator_3_User__c <> null ? operatorRoute[0].Operator_3_Name__c : 'N/A') + ' | ' + 
                                      (operator3_2Z <> null ? operator3_2Z : 'N/A') + ' | ' + 
                                      (operatorRoute[0].Mobile_Phone3__c <> null ? operatorRoute[0].Mobile_Phone3__c : 'N/A');
                    operator4Detail = (operatorRoute[0].Operator_4_User__c <> null ? operatorRoute[0].Operator_4_Name__c : 'N/A') + ' | ' + 
                                      (operator4_2Z <> null ? operator4_2Z : 'N/A') + ' | ' + 
                                      (operatorRoute[0].Mobile_Phone4__c <> null ? operatorRoute[0].Mobile_Phone4__c : 'N/A');
                    operator5Detail = (operatorRoute[0].Operator_5_User__c <> null ? operatorRoute[0].Operator_5_Name__c : 'N/A') + ' | ' + 
                                      (operator5_2Z <> null ? operator5_2Z : 'N/A') + ' | ' + 
                                      (operatorRoute[0].Mobile_Phone5__c <> null ? operatorRoute[0].Mobile_Phone5__c : 'N/A');
                    operator6Detail = (operatorRoute[0].Operator_6_User__c <> null ? operatorRoute[0].Operator_6_Name__c : 'N/A') + ' | ' + 
                                      (operator6_2Z <> null ? operator6_2Z : 'N/A') + ' | ' + 
                                      (operatorRoute[0].Mobile_Phone6__c <> null ? operatorRoute[0].Mobile_Phone6__c : 'N/A');
                }
            }
                                        
            Id productionEngineer;
                                                      
            // Get Operating Field's production engineer
            List<Field__c> operatingField = [SELECT Production_Engineer_User__c 
                                             FROM Field__c 
                                             WHERE Id = :serviceRequest.record.Operating_Field_AMU_Lookup__c];
                
            if (!operatingField.isEmpty())
                productionEngineer = operatingField[0].Production_Engineer_User__c;
    
            Double fixedServiceCostEstimated = [SELECT HOG_Service_Code_MAT__r.Fixed_Service_Cost_Estimated__c
                                                FROM HOG_Work_Order_Type__c
                                                WHERE Id = :serviceRequest.record.HOG_Work_Order_Type__c 
                                                LIMIT 1].HOG_Service_Code_MAT__r.Fixed_Service_Cost_Estimated__c;
                                    
            String workOrderNumber = serviceRequest.workOrderCount > 1 
                ? serviceRequest.record.Work_Order_Number__c + ' - ' + string.valueof(serviceRequest.workOrderCount) 
                : serviceRequest.record.Work_Order_Number__c;
                                                
            String serviceStatus = 
                serviceRequest.record.Recurring_Start_Date__c != null ? 'On Program' 
                : serviceRequest.record.Vendor_Company__c != null ? 'Booked' : 'New Request';

            // W-001435 MB - prepopulating GL codes
            String glCode;
            if(serviceRequest.record.HOG_Work_Order_Type__c != null){
                HOG_Work_Order_Type__c wotype = [SELECT
                        Id,
                        HOG_Service_Code_MAT__r.GL_Code__c
                FROM HOG_Work_Order_Type__c
                WHERE Id =: serviceRequest.record.HOG_Work_Order_Type__c LIMIT 1];

                glCode = wotype.HOG_Service_Code_MAT__r.GL_Code__c;
                System.debug('glCode ' + glCode);
            }

            riglessServicingForm = new HOG_Maintenance_Servicing_Form__c
                (
                    Name = workOrderNumber == null
                        ? serviceRequest.workOrderName + ' - Pending Work Order' 
                        : serviceRequest.workOrderName + ' - ' + workOrderNumber,
                    Work_Order_Number__c = workOrderNumber,
                    Notification_Number__c = serviceRequest.record.Notification_Number__c,
                    RecordTypeId = readRiglessRecordType(serviceRequest.record.HOG_Work_Order_Type__c),
                    Work_Details__c = serviceRequest.record.Work_Details__c,
                    Work_Details_Short__c = serviceRequest.record.Work_Details_Short__c,
                    // W-001435 MB - prepopulating GL codes
                    GL_Code__c = glCode == null ? '' : glCode,
                    Service_Status__c = serviceStatus,
                    HOG_Service_Request_Notification_Form__c = serviceRequest.record.Id,
                    Vendor_Company__c = serviceRequest.record.Vendor_Company__c,
                    Well_Tracker__c = serviceRequest.record.Well_Tracker__c,
                    Supervised__c = serviceRequest.record.Supervised__c,
                    Vendor_Invoicing_Personnel_Is_Required__c = serviceRequest.serviceTimeIsRequired,
                    Service_Time_Is_Required__c = serviceRequest.vendorInvoicingPersonnelIsRequired,
                    Business_Unit_Lookup__c = serviceRequest.record.Business_Unit_Lookup__c,
                    Operating_District_Lookup__c = serviceRequest.record.Operating_District_Lookup__c,
                    Operating_Field_AMU_Lookup__c = serviceRequest.record.Operating_Field_AMU_Lookup__c,                    
                    Facility__c = serviceRequest.record.Facility_Lookup__c,
                    Location__c = serviceRequest.record.Location_Lookup__c,
                    Well_Event__c = serviceRequest.record.Well_Event__c,
                    System__c = serviceRequest.record.System__c,
                    Sub_System__c = serviceRequest.record.Sub_System__c,
                    Functional_Equipment_Level__c = serviceRequest.record.Functional_Equipment_Level__c,
                    Yard__c = serviceRequest.record.Yard__c,
                    Equipment__c = serviceRequest.record.Equipment__c,
                    Control_Centre__c = serviceRequest.controlCentre,
                    Operator_1_User__c = operator1,
                    Operator_2_User__c = operator2,
                    Operator_3_User__c = operator3,
                    Operator_4_User__c = operator4,
                    Operator_5_User__c = operator5,
                    Operator_6_User__c = operator6,
                    Field_Senior__c = fieldSenior,
                    Operator_1_detail__c = operator1Detail,
                    Operator_2_detail__c = operator2Detail,
                    Operator_3_detail__c = operator3Detail,
                    Operator_4_detail__c = operator4Detail,
                    Operator_5_detail__c = operator5Detail,
                    Operator_6_detail__c = operator6Detail,
                    Production_Engineer_User__c = productionEngineer,
                    Fixed_Service_Cost_Estimated__c = fixedServiceCostEstimated,
                    //Fixed_Service_Cost_Estimated__c = serviceRequest.record.HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.Fixed_Service_Cost_Estimated__c,
                    Recurring__c = serviceRequest.record.Recurring_Start_Date__c != null,
                    Main_Work_Centre__c = serviceRequest.record.Main_Work_Centre__c,
                    SAP_Generated_Notification_Number__c = serviceRequest.record.SAP_Generated_Notification_Number__c,
                    SAP_Generated_Work_Order_Number__c = serviceRequest.record.SAP_Generated_Work_Order_Number__c,
                    SAP_Changed_Date__c = serviceRequest.workOrderSAPChangedDate,
                    SAP_Changed_By__c = serviceRequest.workOrderSAPChangedBy,
                    System_Status_Code__c = serviceRequest.workOrderSystemStatusSAP,
                    User_Status_Code__c = serviceRequest.workOrderUserStatusSAP,
                    HOG_Service_Rig_Program__c = serviceRequest.rigProgram,
                    HOG_Notification_Type__c = serviceRequest.notificationType,
                    Primary_Work_Order__c = serviceRequest.record.Primary_Work_Order__c                                              
                 );

            System.debug('\n***************************************\n'
                + 'METHOD: ServiceRequestNotificationUtilities.createRiglessWorkOrder()'
                + '\nriglessServicingForm: ' + riglessServicingForm
                + '\n***************************************\n');
    
        }    
        catch (Exception e) 
        {
            System.debug('\n***************************************\n'
                + 'METHOD: ServiceRequestNotificationUtilities.createRiglessWorkOrder()'
                + '\nException: ' + e.getMessage()
                + '\n***************************************\n');  
            throw e;          
        }

        return riglessServicingForm;                                                        
    }

            
    /********************************************************************************************************
     * Returns the number of work orders for a related well tracker record
     * wellTrackerId - The record id of the well tracker
     * onlyOutstanding - true, Only query records that have service status not 'Completed' or not 'Cancelled'
     *******************************************************************************************************/    
    public static Integer readWellTrackerWorkOrderCount(Id wellTrackerId, Boolean onlyOutstanding)
    {
        Integer wellTrackerOrderCount;
        
        if (onlyOutstanding)
            wellTrackerOrderCount =
                [SELECT
                    COUNT()
                FROM HOG_Maintenance_Servicing_Form__c
                WHERE Well_Tracker__c = :wellTrackerId AND Service_Status__c NOT IN ('Complete', 'Cancelled')];
        else
            wellTrackerOrderCount =
                [SELECT
                    COUNT()
                FROM HOG_Maintenance_Servicing_Form__c
                WHERE Well_Tracker__c = :wellTrackerId];
                    
        return wellTrackerOrderCount;
    }

    /****************************************************************************************************
     * Returns true if the service for a related well tracker record is completed and the well is running
     * wellTrackerId - The record id of the well tracker
     ****************************************************************************************************/    
    public static Boolean readWellTrackerServiceCompletedAndRunning(Id wellTrackerId)
    {
        return 
            [SELECT
                Id
            FROM HOG_Maintenance_Servicing_Form__c
            WHERE Well_Tracker__c = :wellTrackerId AND Service_Status__c = 'Complete' AND Well_On_Production__c = 'Yes'].size() > 0;
    }

    /***********************************************************************************************
     * Returns true if the record is the most recent record in the well tracker
     * wellTrackerId - The record id of the well tracker
     * locationId - The record id of the location
     ***********************************************************************************************/    
    public static Boolean readWellTrackerRecent(Id wellTrackerId, Id locationId)
    {            
        List<Well_Tracker__c> wellTrackerRecord =
            [SELECT
                Id
            FROM Well_Tracker__c
            WHERE Location__c = :locationId
            ORDER BY CreatedDate DESC LIMIT 1];
        
        System.debug('wellTrackerRecord.size(): ' + wellTrackerRecord.size());
        return wellTrackerRecord.size() > 0 ? wellTrackerRecord[0].Id == wellTrackerId : true;                                        
    }      

    /***********************************************************************************************
     * Returns true if the record is the most recent record in the facility tracker
     * wellTrackerId - The record id of the well tracker
     * facilityId - The record id of the facility
     ***********************************************************************************************/    
    public static Boolean readFacilityTrackerRecent(Id wellTrackerId, Id facilityId)
    {            
        List<Well_Tracker__c> wellTrackerRecord =
            [SELECT
                Id
            FROM Well_Tracker__c
            WHERE Facility__c = :facilityId
            ORDER BY CreatedDate DESC LIMIT 1];
        
        return wellTrackerRecord.size() > 0 ? wellTrackerRecord[0].Id == wellTrackerId : true;                                        
    }      


    /*************************************************************************
     * Returns true if the well tracker record has not been modified by others
     * wellTrackerId - The record id of the well tracker
     * wellModifiedStamp - The modified datetime since it was pulled
     *************************************************************************/    
    public static Boolean readWellTrackerModified(Id wellTrackerId, DateTime wellModifiedStamp)
    {                
        // check this record of Well Tracker if it has been modified by others
        List<Well_Tracker__c> wellTrackerRecord =
            [SELECT
                SystemModStamp
            FROM Well_Tracker__c
            WHERE Id = :wellTrackerId];
        
        return wellTrackerRecord.size() > 0 ? wellTrackerRecord[0].SystemModStamp != wellModifiedStamp : false;
    }
        

    /***********************************************************************************************
     * Returns true if the work order is the most recent record in the rigless within a well tracker
     * wellTrackerId - The record id of the well tracker
     * locationId - The record id of the location
     * workOrderId - The record id of the work order
     ***********************************************************************************************/
    public static Boolean readWorkOrderRecent(Id wellTrackerId, Id workOrderId)
    {            
        List<HOG_Maintenance_Servicing_Form__c> workOrderRecord =
            [SELECT
                Id
            FROM HOG_Maintenance_Servicing_Form__c
            WHERE Well_Tracker__c = :wellTrackerId
            ORDER BY CreatedDate DESC LIMIT 1];
        
        return workOrderRecord.size() > 0 ? workOrderRecord[0].Id == workOrderId : true;                                        
    }

    
    /***********************************************************************************************
     * Returns the last Control Centre used when a Well Tracker was created for a specific Location,
     * returns null when no Control Centre has been used
     * locationId - The record id of the location
     ***********************************************************************************************/    
    public static String readLastControlCentre(Id locationId)
    {            
        List<Well_Tracker__c> lastControlCentre =
            [SELECT
                Control_Centre__c
            FROM Well_Tracker__c
            WHERE Location__c = :locationId
            ORDER BY CreatedDate DESC LIMIT 1];
        
        return lastControlCentre.size() > 0 ? lastControlCentre[0].Control_Centre__c : null;                                        
    }


    /***********************************************************************************************
     * Returns the last Control Centre used when a Well Tracker was created for a specific Facility,
     * returns null when no Control Centre has been used
     * facilityId - The record id of the facility
     ***********************************************************************************************/    
    public static String readLastControlCentreFacility(Id facilityId)
    {            
        List<Well_Tracker__c> lastControlCentre =
            [SELECT
                Control_Centre__c
            FROM Well_Tracker__c
            WHERE Facility__c = :facilityId
            ORDER BY CreatedDate DESC LIMIT 1];
        
        return lastControlCentre.size() > 0 ? lastControlCentre[0].Control_Centre__c : null;                                        
    }


    /*******************************************************************************************
     * Returns true if the work order record has not been modified by others
     * workOrderId - The record id of the well tracker
     * workOrderModifiedStamp - The modified datetime since it was pulled
     *******************************************************************************************/    
    public static Boolean readWorkOrderModified(Id workOrderId, DateTime workOrderModifiedStamp)
    {                
        // check this record of Work Order if it has been modified by others
        List<HOG_Maintenance_Servicing_Form__c> workOrderRecord =
            [SELECT
                SystemModStamp
            FROM HOG_Maintenance_Servicing_Form__c
            WHERE Id = :workOrderId];
        
        return workOrderRecord.size() > 0 ? workOrderRecord[0].SystemModStamp != workOrderModifiedStamp : false;
    }    

    /**********************************************************************************************************
     * Returns true if the service notification request record has not been modified by others
     * serviceRequestId - The record id of the service notification request
     * serviceRequestModifiedStamp - The modified datetime since it was pulled
     **********************************************************************************************************/    
    public static Boolean readServiceRequestModified(Id serviceRequestId, DateTime serviceRequestModifiedStamp)
    {                
        // check this record of SNR if it has been modified by others
        List<HOG_Service_Request_Notification_Form__c> serviceRequestRecord =
            [SELECT
                SystemModStamp
            FROM HOG_Service_Request_Notification_Form__c
            WHERE Id = :serviceRequestId];
        
        return serviceRequestRecord.size() > 0 ? serviceRequestRecord[0].SystemModStamp != serviceRequestModifiedStamp : false;
    }    


    /*********************************************************
     * Returns the number of well tracker for a given location
     * locationId - The record id of the location
     *********************************************************/    
    public static Integer readWellTrackerCount(Id locationId)
    {
        return
            [SELECT
                COUNT()
            FROM Well_Tracker__c
            WHERE Location__c = :locationId];

    }


    /************************************************************
     * Returns the number of well tracker for a given facility
     * facilityId - The record id of the facility
     ************************************************************/    
    public static Integer readFacilityTrackerCount(Id facilityId)
    {        
        return
            [SELECT
                COUNT()
            FROM Well_Tracker__c
            WHERE Facility__c = :facilityId];
            
    }


    /***********************************************************************
     * Returns the Average Oil Production for a given location
     * locationId - The record id of the location
     ***********************************************************************/    
    public static Decimal readWellTrackerAverageOilProduction(Id locationId)
    {                
        AggregateResult[] wellTrackerAverageOilProduction =
            [SELECT
                AVG(Oil_Prod_m3_day__c) Average
            FROM Well_Tracker__c
            WHERE Location__c = :locationId];

        Decimal averageOilProduction = (Decimal)wellTrackerAverageOilProduction[0].get('Average');
        return (averageOilProduction == null) ? 0 : averageOilProduction.setscale(1);
    }


    /***********************************************************************
     * Returns true if record is marked as DLFL or record does not exist
     * objectName - The record id of the given FLOC or Equipment object
     * recordId - The record id of the given FLOC or Equipment object
     ***********************************************************************/    
    public static Boolean readDLFL(String objectName, Id recordId)
    {                
        String queryString = 'Select DLFL__c From ' + objectName + ' Where Id =:recordId' ;
        try
        {
            sObject queryResult = Database.query(queryString);
            return (Boolean)queryResult.get('DLFL__c');
        }
        catch (Exception e)
        {
            return true;
        }
    }
            
    
    /***********************************************************************************************************
     * Returns SNR records
     * setIds - The set of record ids to retrieve
     ***********************************************************************************************************/                
    public static List<HOG_Service_Request_Notification_Form__c> readServiceNotificationRequests(Set<Id> setIds)
    {  
        return
            [SELECT
               Id,
               Well_Tracker__c,
               Work_Order_Number__c,
               Notification_Number__c,
               Vendor_Company__c,
               Work_Details__c,
               Work_Details_Short__c,
               Supervised__c,               
               Recurring_Start_Date__c,
               SAP_Changed_Date__c,
               SAP_Changed_By__c,               
               SAP_Generated_Notification_Number__c,
               SAP_Generated_Work_Order_Number__c,
               Generated_Work_Order_Record__c,
               Generated_Rig_Program_Record__c,               
               Well_Tracker__r.Facility__c,
               Well_Tracker__r.Location__c,
               Well_Tracker__r.Control_Centre__c,
               HOG_Work_Order_Type__c,
               HOG_Work_Order_Type__r.HOG_Notification_Type__c,
               HOG_Work_Order_Type__r.HOG_Notification_Type__r.Auto_Generate_Work_Order_Number__c,
               HOG_Work_Order_Type__r.HOG_Notification_Type__r.Auto_Generate_Notification_Number__c,
               HOG_Work_Order_Type__r.HOG_Notification_Type__r.Generate_Numbers_From_SAP__c,                    
               HOG_Work_Order_Type__r.HOG_Notification_Type__r.Notification_Type__c,
               HOG_Work_Order_Type__r.HOG_Notification_Type__r.Order_Type__c,
               HOG_Work_Order_Type__r.HOG_Notification_Type__r.HOG_Service_Code_Group__r.Code_Group__c,
               HOG_Work_Order_Type__r.HOG_Service_Required__r.HOG_Service_Code_Group__r.Code_Group__c,
               HOG_Work_Order_Type__r.HOG_Notification_Type__r.HOG_User_Status__r.Code__c,               
               HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.MAT_Code__c,
               // W-001435 MB - prepopulating GL codes
               HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.GL_Code__c,
               HOG_Work_Order_Type__r.HOG_Service_Code_MAT__r.Fixed_Service_Cost_Estimated__c,               
               HOG_Work_Order_Type__r.HOG_Service_Required__r.Vendor_Invoicing_Personnel_Is_Required__c,
               HOG_Work_Order_Type__r.HOG_Service_Required__r.Service_Time_Is_Required__c,                    
               HOG_Work_Order_Type__r.Record_Type_Name__c,
               HOG_Notification_Type_Priority__r.Priority_Code__c,
               HOG_Notification_Type_Priority_WO__r.Priority_Code__c,
               HOG_Notification_Type_Priority__c,
               HOG_Notification_Type_Priority_WO__c,
               SAP_Object_ID__c,
               Maintenance_Plant__c,
               Main_Work_Centre__c,
               RecordType.Name,
               Business_Unit_Lookup__c,
               Operating_District_Lookup__c,
               Operating_Field_AMU_Lookup__c,
               Operator_Route_Lookup__c,
               Operator_Route_Lookup__r.Operator_1_User__c,
               Operator_Route_Lookup__r.Operator_2_User__c,
               Operator_Route_Lookup__r.Operator_3_User__c,
               Operator_Route_Lookup__r.Operator_4_User__c,
               Operator_Route_Lookup__r.Operator_5_User__c,
               Operator_Route_Lookup__r.Operator_6_User__c,
               Operator_Route_Lookup__r.Operator_1_Name__c,
               Operator_Route_Lookup__r.Operator_2_Name__c,
               Operator_Route_Lookup__r.Operator_3_Name__c,
               Operator_Route_Lookup__r.Operator_4_Name__c,
               Operator_Route_Lookup__r.Operator_5_Name__c,
               Operator_Route_Lookup__r.Operator_6_Name__c,
               Operator_Route_Lookup__r.Mobile_Phone1__c,
               Operator_Route_Lookup__r.Mobile_Phone2__c,
               Operator_Route_Lookup__r.Mobile_Phone3__c,
               Operator_Route_Lookup__r.Mobile_Phone4__c,
               Operator_Route_Lookup__r.Mobile_Phone5__c,
               Operator_Route_Lookup__r.Mobile_Phone6__c,
               Operator_Route_Lookup__r.Field_Senior__c,
               Operating_Field_AMU_Lookup__r.Production_Engineer_User__c,                                      
               Facility_Lookup__c,
               Facility_Lookup__r.Name,
               Location_Lookup__c,
               Location_Lookup__r.Name,
               Equipment__c,
               Equipment__r.Name,
               Equipment__r.Equipment_Number__c,
               UserRecordAccess.HasReadAccess, 
               UserRecordAccess.HasEditAccess,
               Malfunction_Start_Date__c,
               Primary_Work_Order__c,
               Equipment_Down__c
            FROM HOG_Service_Request_Notification_Form__c
            WHERE Id IN :setIds
            ORDER BY Id];
    }

    /***********************************************************************************************************
     * Returns recordtype id of an object
     * sObjectType - The object name where to retrieve the recordtypeid given the recordtypename
     * recordtypename - The recordtypename to retrieve
     ***********************************************************************************************************/    
    public static Id readObjectRecordTypeId(final String sObjectType, final String recordtypename)
    {       
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.readRiglessRecordType()'
            + '\nsObjectType: ' + sObjectType
            + '\nrecordtypename: ' + recordtypename            
            + '\n***************************************\n');                

        List<RecordType> recordType =
            [SELECT
                Id
            FROM RecordType
            WHERE SobjectType = :sObjectType AND Name = :recordtypename
            LIMIT 1];

        return recordType.size() > 0 ? recordType[0].Id : '';       
    }

    /************************************************
     * Get Facility given functionalLocationObjectId
     ************************************************/
    public static Facility__c getFacility(String pFunctionalLocationObjectId) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getFacility()'
            + '\npFunctionalLocationObjectId: ' + pFunctionalLocationObjectId           
            + '\n***************************************\n');

        List<Facility__c> facilityList = [SELECT Id, Name, Functional_Location__c
                                          FROM Facility__c
                                          WHERE SAP_Object_ID__c =: pFunctionalLocationObjectId];
                                          
        System.debug('debug_facilityList: ' + facilityList);                                  

        return (facilityList == null || facilityList.isEmpty()) ? null : facilityList[0];
        
    }

    /************************************************
     * Get Location given functionalLocationObjectId
     ************************************************/
    public static Location__c getLocation(String pFunctionalLocationObjectId) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getLocation()'
            + '\npFunctionalLocationObjectId: ' + pFunctionalLocationObjectId           
            + '\n***************************************\n');
        //We can remove NOT IN statement once we migrate data from location object and remove them from there
        List<Location__c> locationList = [SELECT Id, Name, Facility__c, Functional_Location_Description_SAP__c, Recordtype.Name
                                          FROM Location__c
                                          WHERE SAP_Object_ID__c =: pFunctionalLocationObjectId
                                          AND Recordtype.Name NOT IN ('Well Event')];
                                          
        System.debug('debug_locationList: ' + locationList);  

        return (locationList == null || locationList.isEmpty()) ? null : locationList[0];
    }

     /************************************************
     * Get Well Event given functionalLocationObjectId
     ************************************************/
    public static Well_Event__c getWellEvent(String pFunctionalLocationObjectId) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getWellEvent()'
            + '\npFunctionalLocationObjectId: ' + pFunctionalLocationObjectId           
            + '\n***************************************\n');

        List<Well_Event__c> wellEventList = [SELECT Id, Name, Well_Id__c, Well_Id__r.Facility__c, Functional_Location_Description_SAP__c
                                          FROM Well_Event__c
                                          WHERE SAP_Object_ID__c =: pFunctionalLocationObjectId];
        
        System.debug('debug_wellEventList: ' + wellEventList);  
        
        return (wellEventList == null || wellEventList.isEmpty()) ? null : wellEventList[0];
    }
    
     /************************************************
     * Get System given functionalLocationObjectId
     ************************************************/
    public static System__c getSystem(String pFunctionalLocationObjectId) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getSystem()'
            + '\npFunctionalLocationObjectId: ' + pFunctionalLocationObjectId           
            + '\n***************************************\n');

        List<System__c> systemList = [SELECT Id, Name, Functional_Location_Description_SAP__c
                                      FROM System__c
                                      WHERE SAP_Object_ID__c =: pFunctionalLocationObjectId];
                                      
        System.debug('debug_systemList: ' + systemList);                               

        return (systemList == null || systemList.isEmpty()) ? null : systemList[0];
    }
    
     /************************************************
     * Get Sub-System given functionalLocationObjectId
     ************************************************/
    public static Sub_System__c getSubSystem(String pFunctionalLocationObjectId) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getSubSystem()'
            + '\npFunctionalLocationObjectId: ' + pFunctionalLocationObjectId           
            + '\n***************************************\n');

        List<Sub_System__c> subSystemList = [SELECT Id, Name, Functional_Location_Description_SAP__c
                                             FROM Sub_System__c
                                             WHERE SAP_Object_ID__c =: pFunctionalLocationObjectId];
        
        System.debug('debug_subSystemList: ' + subSystemList);                                     

        return (subSystemList == null || subSystemList.isEmpty()) ? null : subSystemList[0];
    }

    /************************************************
     * Get Functional Equipment Level given functionalLocationObjectId
     ************************************************/
    public static Functional_Equipment_Level__c getFunctionalEquipmentLevel(String pFunctionalLocationObjectId) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getFunctionalEquipmentLevel()'
            + '\npFunctionalLocationObjectId: ' + pFunctionalLocationObjectId           
            + '\n***************************************\n');

        List<Functional_Equipment_Level__c> felList = [SELECT Id, Name, Functional_Location_Description_SAP__c
                                             FROM Functional_Equipment_Level__c
                                             WHERE SAP_Object_ID__c =: pFunctionalLocationObjectId];
        
        System.debug('debug_getFunctionalEquipmentLevel: ' + felList);                                     

        return (felList == null || felList.isEmpty()) ? null : felList[0];
    }

    /************************************************
     * Get Yard given functionalLocationObjectId
     ************************************************/
    public static Yard__c getYard(String pFunctionalLocationObjectId) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getYard()'
            + '\npFunctionalLocationObjectId: ' + pFunctionalLocationObjectId           
            + '\n***************************************\n');

        List<Yard__c> yardList = [SELECT Id, Name, Functional_Location_Description_SAP__c
                                             FROM Yard__c
                                             WHERE SAP_Object_ID__c =: pFunctionalLocationObjectId];
        
        System.debug('debug_sgetYard: ' + yardList);                                     

        return (yardList == null || yardList.isEmpty()) ? null : yardList[0];
    }

    /******************************************
     * Get Equipment given an Equipment Number
     ******************************************/
    public static Equipment__c getEquipment(String pEquipmentNumber) {
        System.debug('\n***************************************\n'
            + 'METHOD: ServiceRequestNotificationUtilities.getEquipment()'
            + '\npEquipmentNumber: ' + pEquipmentNumber           
            + '\n***************************************\n');

        List<Equipment__c> equipmentList = [SELECT Id, Name, Equipment_Number__c,
                                                   Facility__c, Location__c,
                                                   Functional_Location__c
                                            FROM Equipment__c
                                            WHERE Equipment_Number__c =: pEquipmentNumber];
                                            
        System.debug('debug_equipmentList: ' + equipmentList);                                     

        return (equipmentList == null || equipmentList.isEmpty()) ? null : equipmentList[0];
    }

    public static HOG_Service_Request_Notification_Form__c getUpdatedServiceRequestNotificationFormData(
        SAPHOGNotificationServices.GetNotificationResponse response,
        HOG_Service_Request_Notification_Form__c serviceRequestFormRecord,
        HOG_Notification_Type_Priority__c priorityRecord,
        Facility__c facility,
        Location__c location,
        Well_Event__c wellEvent,
        Equipment__c equipment) 
    {
        serviceRequestFormRecord.Work_Details_Short__c = response.Notification.MainDescription;
        serviceRequestFormRecord.Work_Details__c = response.Notification.MainLongDescription;
        serviceRequestFormRecord.SAP_Changed_Date__c =  response.Notification.ChangedDate;
        serviceRequestFormRecord.SAP_Changed_By__c = response.Notification.ChangedBy;
        serviceRequestFormRecord.HOG_Notification_Type_Priority__c = priorityRecord.Id;
        serviceRequestFormRecord.Main_Work_Centre__c = response.Notification.MainWorkCenter;
        serviceRequestFormRecord.Maintenance_Plant__c = response.Notification.MaintenancePlanningPlant;

        if(facility != null){
            serviceRequestFormRecord.Equipment__c = null;
            serviceRequestFormRecord.Location_Lookup__c = equipment.Location__c;
            serviceRequestFormRecord.Facility_Lookup__c = equipment.Facility__c;
            serviceRequestFormRecord.Well_Event__c = null;
        } else if (location != null){
            serviceRequestFormRecord.Equipment__c = null;
            serviceRequestFormRecord.Location_Lookup__c = location.Id;
            serviceRequestFormRecord.Facility_Lookup__c = location.Facility__c;
            serviceRequestFormRecord.Well_Event__c = null;
        } else if (wellEvent != null){
            serviceRequestFormRecord.Equipment__c = null;
            serviceRequestFormRecord.Location_Lookup__c = wellEvent.Well_Id__c;
            serviceRequestFormRecord.Facility_Lookup__c = wellEvent.Well_Id__r.Facility__c;
            serviceRequestFormRecord.Well_Event__c = wellEvent.id;
        } else if (equipment != null){
            serviceRequestFormRecord.Equipment__c = equipment.Id;
            serviceRequestFormRecord.Location_Lookup__c = equipment.Location__c;
            serviceRequestFormRecord.Facility_Lookup__c = equipment.Facility__c;
            serviceRequestFormRecord.Well_Event__c = null;
        }

        serviceRequestFormRecord.Malfunction_Start_Date__c = response.Notification.MalfunctionStartDate;
        serviceRequestFormRecord.Malfunction_End_Date__c = response.Notification.MalfunctionEndDate;

        return serviceRequestFormRecord;
    }

   
    // Service Notification Request wrapper class for passing parameters
    public class ServiceRequest
    {
        public HOG_Service_Request_Notification_Form__c record {get; set;} 
        public String workOrderName {get; set;}     
        public Integer workOrderCount {get; set;}
        public Date workOrderSAPChangedDate {get; set;} 
        public String workOrderSAPChangedBy {get; set;}     
        public String workOrderSystemStatusSAP {get; set;}
        public String workOrderUserStatusSAP {get; set;}
        public Id controlCentre {get; set;}
        public Id rigProgram {get; set;}
        public Id notificationType {get; set;}
        public Boolean serviceTimeIsRequired {get; set;}
        public Boolean vendorInvoicingPersonnelIsRequired {get; set;}       

                
        public ServiceRequest(){}
    }
    
    // Recurrence wrapper class    
    public class Recurrence
    {
        public final String RECURSWEEKLY = 'RecursWeekly';        
        public final String RECURSDAILY = 'RecursDaily';
        public final String RECURSEVERYWEEKDAY = 'RecursEveryWeekday';
        public final String RECURSMONTHLY = 'RecursMonthly';
        public final String RECURSMONTHLYNTH = 'RecursMonthlyNth';
        public final String RECURSYEARLY = 'RecursYearly';  
        public final String RECURSYEARLYNTH = 'RecursYearlyNth';    
        public final String DAILY = 'Daily';
        public final String WEEKLY = 'Weekly';
        public final String MONTHLY = 'Monthly';
        public final String YEARLY = 'Yearly';          
        public final String EVERYWEEKDAY = 'Every weekday';
        public final String EVERY = 'Every';
        public final String ONEVERY = 'On every';
        public final String ONDAY = 'On day';
        public final String ONTHE = 'On the';
        public final String DAY = 'day';
         
        public final Map<Integer, String> MAPDAYOFWEEKMASK = 
            new Map<Integer, String>
            {
                1 => '1', 
                2 => '2', 
                3 => '4', 
                4 => '8', 
                5 => '16', 
                6 => '32', 
                7 => '64'
            };
            
        public final Map<String, String> MAPMASKDAYOFWEEK = 
            new Map<String, String>
            {
                '1' => 'Sunday', 
                '2' => 'Monday', 
                '4' => 'Tuesday', 
                '8' => 'Wednesday', 
                '16' => 'Thursday', 
                '32' => 'Friday', 
                '64' => 'Saturday'
            };
            
        public final Map<String, String> MAPMONTHOFYEAR = 
            new Map<String, String>
            {
                'January' => 'January',
                'February' => 'February',
                'March' => 'March',
                'April' => 'April',
                'May' => 'May',
                'June' => 'June',
                'July' => 'July',
                'August' => 'August',
                'September' => 'September',
                'October' => 'October',
                'November' => 'November',
                'December' => 'December'
            };

        public final Map<String, String> MAPPERIODOPTION =
            new Map<String, String>
            {
                'First' => '1st', 
                'Second' => '2nd', 
                'Third' => '3rd', 
                'Fourth' => '4th', 
                'Last' => 'last' 
            };
            
        public final Integer ALLWEEKDAYSMASK = 62; // excludes Saturday and Sunday, bitmask = 62            
        public final Integer ALLDAYSMASK = 127; // includes Saturday and Sunday, bitmask = 127
        
        public Recurrence(){}
    }
    
    public class NotificationRecordType
    {
        public final String NOTIFICATIONOBJECTNAME = 'HOG_Service_Request_Notification_Form__c';
        public final String WELLTRACKER = 'Well Tracker';
        public final String FACILITYTRACKER = 'Facility Tracker';
        public final String WELL = 'Well ID';
        public final String FACILITY = 'Facility';
        public final String EQUIPMENT = 'Equipment';
        public final String MAINSYSTEM = 'System';
        public final String SUBSYSTEM = 'Sub-system';
        public final String YARD = 'Yard';
        public final String FUNCTIONALEQUIPMENT = 'Functional Equipment Level';
        public final String WELLEVENT = 'Well Event';
        public final String OPERATINGFIELD = 'Operating Field';
        public final String OPERATINGDISTRICT = 'Operating District';
        public final String BUSINESSUNIT = 'Business Unit';

        public final Map<String, String> MAPOBJECTNAME = 
            new Map<String, String>
            {
                WELLTRACKER => 'Location__c', 
                FACILITYTRACKER => 'Facility__c', 
                WELL => 'Location__c',
                FACILITY => 'Facility__c',
                EQUIPMENT => 'Equipment__c',
                MAINSYSTEM => 'Location__c',
                SUBSYSTEM => 'Location__c',
                YARD => 'Location__c',
                FUNCTIONALEQUIPMENT => 'Location__c',               
                OPERATINGFIELD => 'Field__c',
                OPERATINGDISTRICT => 'Operating_District__c',
                BUSINESSUNIT => 'Business_Unit__c',
                WELLEVENT => 'Location__c'
            };

        public final Map<String, String> MAPOBJECTLABEL =
            new Map<String, String>
            {
                WELLTRACKER => 'Location UWI', 
                FACILITYTRACKER => 'Facility', 
                WELL => 'Location UWI',
                FACILITY => 'Facility',
                EQUIPMENT => 'Equipment',
                MAINSYSTEM => 'System',
                SUBSYSTEM => 'Sub-system',
                YARD => 'Yard',
                FUNCTIONALEQUIPMENT => 'Functional Equipment Level',
                OPERATINGFIELD => 'Operating Field',
                OPERATINGDISTRICT => 'Operating District',
                BUSINESSUNIT => 'Business Unit',
                WELLEVENT => 'Well Event'
            };

        public final Map<String, Boolean> MAPSHOWPRODUCTIONIMPACTED =
            new Map<String, Boolean>
            {
                WELLTRACKER => false, 
                FACILITYTRACKER => false, 
                WELL => true,
                FACILITY => true,
                EQUIPMENT => true,
                MAINSYSTEM => true,
                SUBSYSTEM => true,
                YARD => true,
                FUNCTIONALEQUIPMENT => true,
                OPERATINGFIELD => false,
                OPERATINGDISTRICT => false,
                BUSINESSUNIT => false,
                WELLEVENT => true
            };

        public final Map<String, Boolean> MAPSHOWEQUIPMENTDOWN =
            new Map<String, Boolean>
            {
                WELLTRACKER => false, 
                FACILITYTRACKER => false, 
                WELL => true,
                FACILITY => true,
                EQUIPMENT => true,
                MAINSYSTEM => true,
                SUBSYSTEM => true,
                YARD => true,
                FUNCTIONALEQUIPMENT => true,
                OPERATINGFIELD => false,
                OPERATINGDISTRICT => false,
                BUSINESSUNIT => false,
                WELLEVENT => true
            };
        
        public final Map<String, Boolean> MAPSHOWPEQUIPMENTINFO =
            new Map<String, Boolean>
            {
                WELLTRACKER => false, 
                FACILITYTRACKER => false,
                WELL => false,
                FACILITY => false,
                EQUIPMENT => true,
                MAINSYSTEM => false,
                SUBSYSTEM => false,
                YARD => false,
                FUNCTIONALEQUIPMENT => false,
                OPERATINGFIELD => false,
                OPERATINGDISTRICT => false,
                BUSINESSUNIT => false,
                WELLEVENT => false
            };

        public final Map<String, Boolean> MAPSHOWPVRAVGINFO =
            new Map<String, Boolean>
            {
                WELLTRACKER => false, 
                FACILITYTRACKER => false,
                WELL => true,
                FACILITY => false,
                EQUIPMENT => true,
                MAINSYSTEM => false,
                SUBSYSTEM => false,
                YARD => false,
                FUNCTIONALEQUIPMENT => false,
                OPERATINGFIELD => false,
                OPERATINGDISTRICT => false,
                BUSINESSUNIT => false,
                WELLEVENT => true
            };

        public final Map<String, Boolean> MAPSHOWTRACKERINFO =
            new Map<String, Boolean>
            {
                WELLTRACKER => true, 
                FACILITYTRACKER => true,
                WELL => true,
                FACILITY => true,
                EQUIPMENT => false,
                MAINSYSTEM => false,
                SUBSYSTEM => false,
                YARD => false,
                FUNCTIONALEQUIPMENT => false,
                OPERATINGFIELD => false,
                OPERATINGDISTRICT => false,
                BUSINESSUNIT => false,
                WELLEVENT => false
            };

        public NotificationRecordType(){}            
    }
}